Overview | Package | Class | Tree | Deprecated | Index | Help
| Oracle TopLink API Reference 10g Release 3 (10.1.3) B13698-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.toplink.mappings
Class DatabaseMapping

`java.lang.Object
oracle.toplink.mappings.DatabaseMapping`

All Implemented Interfaces:
  java.lang.Cloneable, java.io.Serializable

Direct Known Subclasses:
  AbstractCompositeDirectCollectionMapping, AbstractDirectMapping, AbstractTransformationMapping, AggregateMapping, ForeignReferenceMapping, XMLAnyCollectionMapping, XMLAnyObjectMapping

public abstract class DatabaseMapping
extends java.lang.Object
implements java.lang.Cloneable, java.io.Serializable

Purpose: Defines how an attribute of an object maps to and from the database

Responsibilities:

- Define type of relationship (1:1/1:M/M:M/etc.)
- Define instance variable name and fields names required
- Define any additional properties (ownership, indirection, read only, etc.)
- Control building the value for the instance variable from the database row
- Control building the database fields from the object
- Control any pre/post updating/inserting/deleting required to maintain the relationship
- Merges object changes for unit of work.
- Clones objects for unit of work.
- cache computed information to optimize performance

Since:
  TOPLink/Java 1.0
See Also:
  Serialized Form

Constructor Summary
`DatabaseMapping()` PUBLIC: Default constructor.

Method Summary
`AttributeAccessor` | `getAttributeAccessor()` ADVANCED: Return the attributeAccessor.
`java.lang.Class` | `getAttributeClassification()` PUBLIC: The classification type for the attribute this mapping represents
`java.lang.String` | `getAttributeName()` PUBLIC: Return the name of the attribute set in the mapping.
`java.lang.String` | `getGetMethodName()` PUBLIC: This method is invoked reflectively on the reference object to return the value of the attribute in the object.
`ClassDescriptor` | `getReferenceClassDescriptor()` PUBLIC: Return the referenceDescriptor.
`java.lang.String` | `getSetMethodName()` PUBLIC: This method is invoked reflectively on the reference object to set the value of the attribute in the object.
`boolean` | `isUsingMethodAccess()` PUBLIC: Return if method access is used.
`void` | `readOnly()` PUBLIC: To make mapping read only.
`void` | `readWrite()` PUBLIC: The mapping can be dynamically made either readOnly or readWriteOnly.
`void` | `setAttributeAccessor(AttributeAccessor attributeAccessor)` ADVANCED: Set the attributeAccessor.
`void` | `setAttributeName(java.lang.String attributeName)` PUBLIC: Sets the name of the attribute in the mapping.
`void` | `setGetMethodName(java.lang.String methodName)` PUBLIC: This method is invoked reflectively on the reference object to return the value of the attribute in the object.
`void` | `setIsReadOnly(boolean aBoolean)` PUBLIC: Set this mapping to be read only.
`void` | `setSetMethodName(java.lang.String methodName)` PUBLIC: This method is invoked reflectively on the reference object to get the value of the attribute.
`void` | `setWeight(java.lang.Integer newWeight)` ADVANCED: Set the weight of the mapping, used to sort mappings DirectToField Mappings have a default weight of 1 while all other Mappings have a default weight of MAXINT.
`void` | `simpleAddToCollectionChangeRecord(java.lang.Object referenceKey, java.lang.Object changeSetToAdd, ObjectChangeSet changeSet, Session session)` ADVANCED: This method is used to add an object to a collection once the changeSet is applied.
`void` | `simpleRemoveFromCollectionChangeRecord(java.lang.Object referenceKey, java.lang.Object changeSetToAdd, ObjectChangeSet changeSet, Session session)` ADVANCED: This method is used to remove an object from a collection once the changeSet is applied.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### DatabaseMapping

    public DatabaseMapping()

  PUBLIC: Default constructor.

Method Detail

### getAttributeAccessor

    public AttributeAccessor getAttributeAccessor()

  ADVANCED: Return the attributeAccessor. The attribute accessor is responsible for setting and retrieving the attribute value from the object for this mapping.

### getAttributeClassification

    public java.lang.Class getAttributeClassification()

  PUBLIC: The classification type for the attribute this mapping represents

### getAttributeName

    public java.lang.String getAttributeName()

  PUBLIC: Return the name of the attribute set in the mapping.

### getGetMethodName

    public java.lang.String getGetMethodName()

  PUBLIC: This method is invoked reflectively on the reference object to return the value of the attribute in the object. This method returns the name of the getMethodName or null if not using method access.

### getReferenceClassDescriptor

    public ClassDescriptor getReferenceClassDescriptor()

  PUBLIC: Return the referenceDescriptor. This is a descriptor which is associated with the reference class.

### getSetMethodName

    public java.lang.String getSetMethodName()

  PUBLIC: This method is invoked reflectively on the reference object to set the value of the attribute in the object. This method returns the name of the setMethodName or null if not using method access.

### isUsingMethodAccess

    public boolean isUsingMethodAccess()

  PUBLIC: Return if method access is used.

### readOnly

    public void readOnly()

  PUBLIC: To make mapping read only. Read-only mappings can be used if two attributes map to the same field. Read-only mappings cannot be used for the primary key or other required fields.

### readWrite

    public void readWrite()

  PUBLIC: The mapping can be dynamically made either readOnly or readWriteOnly. This makes mapping go back to default mode.

### setAttributeAccessor

    public void setAttributeAccessor(AttributeAccessor attributeAccessor)

  ADVANCED: Set the attributeAccessor. The attribute accessor is responsible for setting and retrieving the attribute value from the object for this mapping. This can be set to an implementor of AttributeAccessor if the attribute requires advanced conversion of the mapping value, or a real attribute does not exist.

### setAttributeName

    public void setAttributeName(java.lang.String attributeName)

  PUBLIC: Sets the name of the attribute in the mapping.

### setGetMethodName

    public void setGetMethodName(java.lang.String methodName)

  PUBLIC: This method is invoked reflectively on the reference object to return the value of the attribute in the object. This method sets the name of the getMethodName.

### setIsReadOnly

    public void setIsReadOnly(boolean aBoolean)

  PUBLIC: Set this mapping to be read only. Read-only mappings can be used if two attributes map to the same field. Read-only mappings cannot be used for the primary key or other required fields.

### setSetMethodName

    public void setSetMethodName(java.lang.String methodName)

  PUBLIC: This method is invoked reflectively on the reference object to get the value of the attribute. The method defined on the object should actually return the value that needs to be set in the attribute accessor.

### setWeight

    public void setWeight(java.lang.Integer newWeight)

  ADVANCED: Set the weight of the mapping, used to sort mappings DirectToField Mappings have a default weight of 1 while all other Mappings have a default weight of MAXINT. Ordering of Mappings can be achieved by setting the weight of a particular mapping to a value within the above mentioned limits. By ordering mappings the user can control what order relationships are processed by TopLink.

### simpleAddToCollectionChangeRecord

    public void simpleAddToCollectionChangeRecord(java.lang.Object referenceKey,
                                                  java.lang.Object changeSetToAdd,
                                                  ObjectChangeSet changeSet,
                                                  Session session)
                                           throws DescriptorException

  ADVANCED: This method is used to add an object to a collection once the changeSet is applied. The referenceKey parameter should only be used for direct Maps.
  Throws:
    `DescriptorException`

### simpleRemoveFromCollectionChangeRecord

    public void simpleRemoveFromCollectionChangeRecord(java.lang.Object referenceKey,
                                                       java.lang.Object changeSetToAdd,
                                                       ObjectChangeSet changeSet,
                                                       Session session)
                                                throws DescriptorException

  ADVANCED: This method is used to remove an object from a collection once the changeSet is applied. The referenceKey parameter should only be used for direct Maps.
  Throws:
    `DescriptorException`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Copyright © 1998, 2006, Oracle. All Rights Reserved.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD